-- animal.e class hierarchy for benchmark tests.
-- Adapted from Rod Jackson's Quartz.
include diamondlite.e
without warning
without trace


procedure my_sound (integer f)
end procedure


global constant Animal=class("Animal",Entity)

property("Name",INSTANCE,NONE)
property("IsDomesticated",INSTANCE,FALSE)

function Animal_new_2(object name,object isDomesticated)
   entity new 
   new=call_method(super(),"new",NONE)
   set_property(new,"Name",name)
   set_property(new,"IsDomesticated",isDomesticated)
   return new
end function

function Animal_new_1(object name)
   return Animal_new_2(name,FALSE)   
end function

method("new",1,CLASS,routine_id("Animal_new_1"))
method("new",2,CLASS,routine_id("Animal_new_2")) 

function Animal_MakeNoise_0()      
   my_sound(800)
   my_sound(0)
   return NIL
end function

method("MakeNoise",0,INSTANCE,routine_id("Animal_MakeNoise_0"))

end_class()


global constant Mammal=class("Mammal",Animal)

property("HasTail",INSTANCE,TRUE)
property("HasFur",INSTANCE,TRUE)
property("IsAquatic",INSTANCE,FALSE)

function Mammal_new_5 (object name, object isDomesticated,object hasTail,
object hasFur,object isAquatic)
   entity new
   new=call_method(super(),"new",{name,isDomesticated})
   set_property(new,"HasTail",hasTail)
   set_property(new,"HasFur", hasFur)
   set_property(new,"IsAquatic",isAquatic)
   return new
end function

function Mammal_new_4(object name,object isDomesticated,object hasTail,
object hasFur)
   return Mammal_new_5(name,isDomesticated,hasTail,hasFur,FALSE)
end function

function Mammal_new_3(object name,object isDomesticated,object hasTail)
   return Mammal_new_5(name,isDomesticated,hasTail,TRUE,FALSE)
end function 

function Mammal_new_2(object name,object isDomesticated)
   return Mammal_new_5(name,isDomesticated,TRUE,TRUE,FALSE)
end function

function Mammal_new_1(object name)
   return Mammal_new_5(name,FALSE,TRUE,TRUE,FALSE)
end function


method("new",1,CLASS,routine_id("Mammal_new_1"))
method("new",2,CLASS,routine_id("Mammal_new_2"))
method("new",3,CLASS,routine_id("Mammal_new_3"))
method("new",4,CLASS,routine_id("Mammal_new_4"))
method("new",5,CLASS,routine_id("Mammal_new_5"))

end_class()


global constant Bird=class("Bird",Animal)

property("Wingspan",INSTANCE,0)
property("MaxSpeed",INSTANCE,0)

end_class()


global constant Fish=class("Fish",Animal)

function Fish_MakeNoise_0()
    -- no sound             
    my_sound(0)
   return NIL
end function

method("MakeNoise",0,INSTANCE,routine_id("Fish_MakeNoise_0"))

end_class()


global constant Cat=class("Cat",Mammal)

property("IsDeclawed",INSTANCE,FALSE) 

function Cat_Get_Test(integer itor)
   object ret
   for i=1 to itor do
      ret=get_property(this(),"IsDeclawed")      
   end for 
   return ret
end function 

method("Get_Test",1,INSTANCE,routine_id("Cat_Get_Test"))

function Cat_Set_Test(integer itor)
   for i=1 to itor do
      set_property(this(),"IsDeclawed",TRUE)      
   end for 
   return NIL
end function 

method("Set_Test",1,INSTANCE,routine_id("Cat_Set_Test"))


end_class()


global constant Dog=class("Dog",Mammal)

end_class()



